#! /usr/bin/perl -w

# Copyright (c) 2007 Takahiro Shinozaki

# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:

# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.


# Sat Dec 29 15:16:30 JST 2007
# Takahiro Shinozaki

# divide file into multiple blocks.

if (@ARGV != 4) {
    die "$0 scp num outd stem\n";
}

$scpf = $ARGV[0];
$numb = $ARGV[1];
$outd = $ARGV[2];
$stem = $ARGV[3];

open(IN, $scpf) || die "$! : $scpf\n";
for ($i=0; $i<$numb; $i++) {
    $outfh = "out$i";
    $j=$i+1;
    $outf = "$outd/$stem.$j"; # file extension starts with 1 (not 0)
    open($outfh, ">$outf") || die "$! : $outf\n";
    $out[$i]=$outfh;
}
$i=0;
while (<IN>) {
    $i = 0 if ($i == $numb);
    $outfh = $out[$i];
    print $outfh $_;
    $i++;
}
